(function() {
  var ObjectSelection, SelectionView,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  ObjectSelection = require("./object-selection");

  module.exports = SelectionView = (function() {
    function SelectionView(svgDocument) {
      this.svgDocument = svgDocument;
      this.onChangePreselected = bind(this.onChangePreselected, this);
      this.model = this.svgDocument.getSelectionModel();
      this.objectPreselection = new ObjectSelection(this.svgDocument, {
        "class": 'object-preselection'
      });
      this.model.on('change:preselected', this.onChangePreselected);
    }

    SelectionView.prototype.getObjectSelection = function() {
      return this.objectSelection;
    };

    SelectionView.prototype.onChangePreselected = function(arg) {
      var object;
      object = arg.object;
      return this.objectPreselection.setObject(object);
    };

    return SelectionView;

  })();

}).call(this);
